;
; usewdm.inc
;
;           wdm- Windows
;     wdm.h, ntdef.h, ntstatus.h  ..
;     .    wdm.h        .
;

OPTION DOTNAME

;
;    
;

; NTSTATUS :)
NTSTATUS			typedef	DWORD
STATUS_SUCCESS		equ 0
STATUS_UNSUCCESSFULL	equ 0C0000001H
STATUS_NOT_IMPLEMENTED	equ 0C0000002H

;     MajorTable  DRIVER_OBJECT
IRP_MJ_CREATE                   equ	0
IRP_MJ_CLOSE                    equ	2
IRP_MJ_READ                     equ	3
IRP_MJ_WRITE                    equ	4
IRP_MJ_DEVICE_CONTROL           equ	0EH
; .      MajorFunction
IRP_MJ_MAXIMUM_FUNCTION	equ	1BH

;   
FILE_DEVICE_UNKNOWN		equ	22H

;   
METHOD_BUFFERED			equ	0

;  
FILE_ANY_ACCESS			equ	0

FALSE			equ	0
TRUE				equ	1

;  
CHAR		typedef	BYTE		
CCHAR	typedef	CHAR
UCHAR	typedef	BYTE
PCHAR		typedef	ptr	CHAR
PVOID		typedef	ptr	CHAR
WCHAR		typedef	WORD
PWCHAR		typedef	ptr	WCHAR
PWSTR		typedef	PWCHAR
USHORT		typedef	WORD
CSHORT		typedef	WORD
LONG			typedef	DWORD
ULONG		typedef	DWORD
PULONG		typedef	ptr	ULONG
BOOLEAN	typedef	UCHAR
DEVICE_TYPE	typedef	DWORD

;  - ,      
PDEVICE_OBJECT	typedef	ptr	DWORD
PDRIVER_EXTENSION	typedef	ptr	DWORD
PFAST_IO_DISPATCH	typedef	ptr	DWORD
PDRIVER_INITIALIZE	typedef	ptr	DWORD
PDRIVER_STARTIO	typedef	ptr	DWORD
PDRIVER_UNLOAD	typedef	ptr	DWORD
PDRIVER_DISPATCH	typedef	ptr	DWORD

;     
UNICODE_STRING STRUC
	Length_	USHORT	?	;  
	MaximumLength	USHORT	?	;  
	Buffer		PWSTR	?	;    
UNICODE_STRING ENDS
PUNICODE_STRING	typedef ptr UNICODE_STRING

;  DRIVER_OBJECT.
DRIVER_OBJECT	STRUC, NONUNIQUE
	Type_		CSHORT	?
	Size_		CSHORT	?

	DeviceObject	PDEVICE_OBJECT	?
	Flags		ULONG		?

	DriverStart	PVOID		?
	DriverSize	ULONG		?
	DriverSection	PVOID		?
	DriverExtension	PDRIVER_EXTENSION	?

	DriverName		UNICODE_STRING	<>

	HardwareDatabase	PUNICODE_STRING	?

	FastIoDispatch	PFAST_IO_DISPATCH	?

	DriverInit		PDRIVER_INITIALIZE	?
	DriverStartIo	PDRIVER_STARTIO		?
	DriverUnload	PDRIVER_UNLOAD		?
	MajorFunction	PDRIVER_DISPATCH ((1+IRP_MJ_MAXIMUM_FUNCTION)*(TYPE PDRIVER_DISPATCH)) DUP(?)
DRIVER_OBJECT	ENDS
PDRIVER_OBJECT		typedef ptr DRIVER_OBJECT

; - - - - - - - - - - - - - - - - - - - - - - - -
;  
PLIST_ENTRY typedef ptr BYTE
LIST_ENTRY STRUCT
	Flink PLIST_ENTRY ?
	Blink PLIST_ENTRY ?
LIST_ENTRY ENDS

IO_STATUS_BLOCK STRUC
 UNION
  Status  NTSTATUS	?
  Pointer PVOID	?
 ENDS
 Information DWORD	?
IO_STATUS_BLOCK ENDS
PIO_STATUS_BLOCK	typedef	ptr	IO_STATUS_BLOCK

KPROCESSOR_MODE typedef CCHAR

KIRQL typedef UCHAR

PKEVENT	typedef	PVOID

LARGE_INTEGER STRUC
	LowPart	ULONG	?
	HighPart	ULONG	?
LARGE_INTEGER ENDS

PDRIVER_CANCEL	typedef	PVOID	

;  IO_STACK_LOCATION
IO_STACK_LOCATION	STRUC
	MajorFunction	UCHAR	?
	MinorFunction	UCHAR	?
	Flags		UCHAR	?
	Control	UCHAR	?

	UNION	Parameters
		STRUCT Other
			Argument1	PVOID	?
			Argument2	PVOID	?
			Argument3	PVOID	?
			Argument4	PVOID	?
		ENDS
		STRUCT DeviceIoControl
			OutputBufferLength	ULONG	?
			InputBufferLength 	ULONG	?
			IoControlCode		ULONG	?
			Type3InputBuffer	PVOID	?
		ENDS
		; <...>
	ENDS

	DeviceObject	PDEVICE_OBJECT ?

	FileObject	PVOID ?

	CompletionRoutine	PVOID ?

	Context	PVOID ?
IO_STACK_LOCATION ENDS
PIO_STACK_LOCATION typedef ptr IO_STACK_LOCATION

;  KAPC
KAPC	STRUC
	Type_	CSHORT	?
	Size_	CSHORT	?
	Spare0	ULONG	?
	Thread	PVOID	?
	ApcListEntry	LIST_ENTRY	<>
	KernelRoutine		PVOID ?
	RundownRoutine	PVOID ?
	NormalRoutine		PVOID ?
	NormalContext		PVOID ?

	SystemArgument1	PVOID ?
	SystemArgument2	PVOID ?
	ApcStateIndex		CCHAR ?
	ApcMode		KPROCESSOR_MODE ?
	Inserted		BOOLEAN ?
KAPC ENDS

;  KDEVICE_QUEUE_ENTRY
KDEVICE_QUEUE_ENTRY STRUC
	DeviceListEntry	LIST_ENTRY	<>
	SortKey		ULONG	?
	Inserted		BOOLEAN	?
KDEVICE_QUEUE_ENTRY ENDS
PKDEVICE_QUEUE_ENTRY	typedef ptr KDEVICE_QUEUE_ENTRY

;  IRP
_IRP STRUC, NONUNIQUE
	Type_ CSHORT ?
	Size_ USHORT ?

	PMDL PVOID ?
	
	Flags ULONG ?

	UNION	AssociatedIrp
		MasterIrp 	PVOID	?
		IrpCount  	LONG	?
		SystemBuffer	PVOID	?
	ENDS

	ThreadListEntry LIST_ENTRY <>

	IoStatus	IO_STATUS_BLOCK <>

	Requestor_Mode KPROCESSOR_MODE ?

	PendingReturned BOOLEAN ?

	StackCount		CHAR ?
	CurrentLocation	CHAR ?

	Cancel	BOOLEAN ?

	CancelIrql	KIRQL ?

	ApcEnvironment	CCHAR	?

	AllocationFlags	UCHAR ?

	UserIosb	PIO_STATUS_BLOCK	?
	UserEvent	PKEVENT	?
	
	UNION	Overlay
		UNION	AsynchronousParameters
			UserApcRoutine PVOID ?
			UserApcContext PVOID ?
		ENDS
		AllocationSize LARGE_INTEGER <>
	ENDS

	CancelRoutine	PDRIVER_CANCEL ?

	UserBuffer	PVOID ?
	
	UNION Tail
	STRUCT	Overlay
		UNION
			DeviceQueueEntry	KDEVICE_QUEUE_ENTRY	<>
			DriverContext PVOID 4 DUP (?)
		ENDS

		Thread	PVOID	?

		AuxiliaryBuffer	PCHAR	?

		ListEntry		LIST_ENTRY	<>
		UNION
			CurrentStackLocation	PIO_STACK_LOCATION	?
			PacketType	ULONG	?
		ENDS
	ENDS

	Apc		KAPC	<>
	CompletionKey	PVOID	?
	ENDS	; Tail

_IRP ENDS
PIRP 	typedef	ptr	_IRP

;
;    wdm.lib
;

;   --    :)
DbgPrint proto near C,:PCHAR,:VARARG

;   
IoCreateDevice proto near STDCALL,:PDRIVER_OBJECT,:ULONG,:PUNICODE_STRING,:DEVICE_TYPE,:ULONG,:BOOLEAN,:PDEVICE_OBJECT

;   
IoCreateSymbolicLink proto near STDCALL,:PUNICODE_STRING,:PUNICODE_STRING

;   
IoDeleteSymbolicLink proto near STDCALL,:PUNICODE_STRING

;   
IoDeleteDevice proto near STDCALL,:PDEVICE_OBJECT

;   
RtlInitUnicodeString proto near STDCALL,:PUNICODE_STRING,:PWSTR

;   
RtlFreeUnicodeString proto near STDCALL,:PUNICODE_STRING

;     
; Re:  _fastcall,       syscall
@IofCompleteRequest@8 proto near SYSCALL

;  !

